Subject: Re: [PATCH] Rate should be u64 to avoid integer overflow at high speeds (>= ~35Gbit)

From: Chris Friesen <[email-masked]>
Date: Tue, 12 Mar 2013 09:53:43 -0600

On 03/12/2013 09:42 AM, Thomas Graf wrote:
> On 03/12/13 at 08:29am, Chris Friesen wrote:
>> The only problem I see is that you can't set the multiplier with a
>> new tool and then query the rate with old tools.
>>
>> But you're going to run into that problem with the old tools no
>> matter what you do--and not doing anything is a crappy option as
>> well.
>>
>> Some kind of multiplier or shift makes as much sense as anything
>> else. With old tools you get current behaviour, with new tools you
>> can specify a multiplying factor to trade off resolution vs
>> precision.
>
> The introduction of a shift operator or multiplier introduces
> inprecision. I'd much rather see new 64bit Netlink attributes
> that, if present, replace the old rate values and statistics.

I have strong opinions either way, but I don't think "imprecision" is a 
problem in practice.

With the shift/multiplier we would have 32 bits of precision.  Do you 
really expect that someone will care about the difference between 
8589934592 and 8589934593?  Or the difference between 40000000000 and 
40000000010?

Chris